#include <string.h>
#include "JOYPAD.h"

JOYPAD JoyPad;

void KEY_Init(void)
{
GPIO_Digital_Input(&GPIOD_IDR, _GPIO_PINMASK_2);
GPIO_Digital_Input(&GPIOD_IDR, _GPIO_PINMASK_4);
GPIO_Digital_Input(&GPIOA_IDR, _GPIO_PINMASK_6);
GPIO_Digital_Input(&GPIOB_IDR, _GPIO_PINMASK_5);

GPIO_Digital_Input(&GPIOD_IDR, _GPIO_PINMASK_10);
GPIO_Digital_Input(&GPIOD_IDR, _GPIO_PINMASK_14);
GPIO_Digital_Input(&GPIOA_IDR, _GPIO_PINMASK_10);
GPIO_Digital_Input(&GPIOA_IDR, _GPIO_PINMASK_14);

GPIO_Digital_Input(&GPIOC_IDR, _GPIO_PINMASK_13);
}

void JOYPAD_SetState(int pad, int index, BYTE val)
{
        DWORD* PadBit=&JoyPad.m_PadBit[pad&0x1];
        DWORD mask=index;
        if(pad&0x2)mask<<=8;
        if(val)*PadBit|=mask;
        else *PadBit&=~mask;
}

void JOYPAD_InputBursh(BYTE burst)
{

        if(burst&0x1&&JoyPad.m_bStrobe==0)JoyPad.m_bStrobe = 1;
        if(!(burst&0x1)&&JoyPad.m_bStrobe)JoyPad.m_bStrobe = 0; JoyPad.m_CurIndex[0] = JoyPad.m_CurIndex[1]=0;
}

BYTE JOYPAD_GetValue(int padbit)
{

        BYTE ret;
        ret = JoyPad.m_PadBit[padbit] >> JoyPad.m_CurIndex[padbit] & 0x1;
        JoyPad.m_CurIndex[padbit]++;
        
        if(JoyPad.m_CurIndex[padbit]>=24)JoyPad.m_CurIndex[0]=0;JoyPad.m_CurIndex[1]=0; //memset(JoyPad.m_CurIndex,0,sizeof(JoyPad.m_CurIndex));

        return ret;

//ret = (!KEY8<<7)|(!KEY7<<6)|(!KEY6<<5)|(!KEY5<<4)|(!KEY4<<3)|(!KEY3<<2)|(!KEY2<<1)|!KEY1;
//return ret;
}

void Get_key(void)
{
        DWORD* PadBit=&JoyPad.m_PadBit[0];
        BYTE KEY1, KEY2, KEY3, KEY4, KEY5, KEY6, KEY7, KEY8;
        
        if (Button(&GPIOD_IDR, 14, 1, 0)) KEY1 = 1;
         else KEY1 = 0;
        if (Button(&GPIOD_IDR, 10, 1, 0)) KEY2 = 1;
         else KEY2 = 0;
        if (Button(&GPIOA_IDR, 10, 1, 0))KEY3 = 1;
         else KEY3 = 0;
        if (Button(&GPIOC_IDR, 13, 1, 0))KEY4 = 1;
         else KEY4 = 0;
        if (Button(&GPIOD_IDR, 4, 1, 0)) KEY5 = 1;
         else KEY5 = 0;
        if (Button(&GPIOB_IDR, 5, 1, 0)) KEY6 = 1;
         else KEY6 = 0;
        if (Button(&GPIOD_IDR, 2, 1, 0)) KEY7 = 1;
         else KEY7 = 0;
        if (Button(&GPIOA_IDR, 6, 1, 0)) KEY8 = 1;
         else KEY8 = 0;
        
        *PadBit=(KEY8<<7)|(KEY7<<6)|(KEY6<<5)|(KEY5<<4)|(KEY4<<3)|(KEY3<<2)|(KEY2<<1)|KEY1;
}
//                     R       L         D        U       ST       SE        B     A
//        keyvalue=(KEY<<7)|(KEY<<6)|(KEY<<5)|(KEY<<4)|(KEY<<3)|(KEY<<2)|(KEY<<1)|KEY