#ifndef _MAPPER087_H_
#define _MAPPER087_H_


void    Mapper087_Reset()
{
	SetPROM_32K_Bank2( 0, 1, 2, 3 );
	SetVROM_8K_Bank(0);
}

void	Mapper087_Write( WORD addr, BYTE str )
{
	if( addr == 0x6000 ) {
		SetVROM_8K_Bank( (str & 0x02)>>1 );
	}
}

void    Mapper087_Init()
{
        NES_Mapper.Reset = Mapper087_Reset;
        NES_Mapper.Write = Mapper087_Write;
}

#endif