//#include "key.h"
#include "Waves'NES.c"
//#include "jpegbmp.h"
//#include "sysfile.h"

extern void App_Main(void);
short errg;
unsigned int xPos, yPos;
unsigned char  numer_f;
char file_name[255][16];
FAT32_DIRENT Files;

void WriteLine(char* txt){
  xPos = 130;
  yPos += 15;
  TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_GRAY, FO_HORIZONTAL);
  TFT_Write_Text(txt, xPos, 45+yPos);
}

void ClearDisplay(){
    xPos = 130;
    yPos = 0;
    TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);
    TFT_Set_Pen(CL_BLACK, 1);
    TFT_Rectangle(120, 50, 319, 239);
}

char F_FILE(char* fileName){
  int idx;

  idx = 0;
  while ((idx < 15) && (Files.NameExt[idx] != 0))
  {
    idx++;
  }

  if ( idx < 4 ){
    return 0;
     }
  if ((Files.NameExt[idx-4] == '.' ) &&
      ((Files.NameExt[idx-3] == 'n') || (Files.NameExt[idx-3] == 'N' )) &&
      ((Files.NameExt[idx-2] == 'e') || (Files.NameExt[idx-2] == 'E' )) &&
      ((Files.NameExt[idx-1] == 's') || (Files.NameExt[idx-1] == 'S' )) ||

      (Files.NameExt[idx-4] == '.' ) &&
      ((Files.NameExt[idx-3] == 'n') || (Files.NameExt[idx-3] == 'N' )) &&
      ((Files.NameExt[idx-2] == 's') || (Files.NameExt[idx-2] == 'S' )) &&
      ((Files.NameExt[idx-1] == 'f') || (Files.NameExt[idx-1] == 'F' ))){
    return 1;
    }
  else{
    return 0;
    }
}

void Search_file(void){

      unsigned int i = 0;
      numer_f = 0;

         errg = FAT32_FindFirst(&Files);
      if (errg == FOUND)
      {
        if(F_FILE(Files.NameExt) == 1){
        TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_GRAY, FO_HORIZONTAL);
        strncpy(file_name[numer_f],Files.NameExt,16);
        numer_f = numer_f + 1;
        }
      }

      do
      {
        errg = FAT32_FindNext(&Files);
        if (errg == FOUND)
        {

          if(F_FILE(Files.NameExt) == 1){
          TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_GRAY, FO_HORIZONTAL);
          strncpy(file_name[numer_f],Files.NameExt,16);
          numer_f = numer_f + 1;
          }
       }
       }while (errg == FOUND);

}

void file_ok(void){

int y = 0,num_file,count;
char flag = 0;
unsigned char i;
char lcd_buffe[128];

        for(count=0;count<10;count++)WriteLine(file_name[count]);

        num_file = 0;
        count = 0;

        while(flag == 0){

        TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_BLACK, FO_HORIZONTAL);
        TFT_Write_Text(">", 110, (60 + y)-15);
        TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_WHITE, FO_HORIZONTAL);
        TFT_Write_Text(">", 110, 60 + y);
        TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_BLACK, FO_HORIZONTAL);
        TFT_Write_Text(">", 110, (60 + y)+15);


        delay_ms(100);

        if (Button(&GPIOD_IDR, 4, 1, 0)){     // UP

        if(count > 0){
        count--;
        y = y - 15;
        }

        if(y < 0){
        if(count+1 > 0){
        ClearDisplay();
        num_file = num_file - 10;
        for(i=0;i<10;i++) WriteLine(file_name[i+num_file]);
        TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_BLACK, FO_HORIZONTAL);
        TFT_Write_Text(">", 110, 60);
        y = 135;
        }
         }
        }

        if (Button(&GPIOB_IDR, 5, 1, 0)){     // DOWN

          if(count+1!=numer_f){
          y = y + 15;
          count++;
            }
          }

        if(y>135){
        ClearDisplay();
        num_file = num_file + 10;
        for(i=0;i<10;i++) WriteLine(file_name[i+num_file]);
        TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_BLACK, FO_HORIZONTAL);
        TFT_Write_Text(">", 110, 195);
        y = 0;
          }

        if (Button(&GPIOC_IDR, 13, 1, 0)){     // OK
        TFT_Fill_Screen(CL_BLACK);
        RUN_WaveNES(file_name[count]);
        flag = 1;
        }

        }
}
/////////////////////////////////////////////////////////////////////////////
void display_menu(void)
{
        TFT_Fill_Screen(CL_BLACK);
        TFT_Set_Pen(CL_YELLOW, 1);
        TFT_LIne(20,  46, 300,  46);
        TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_LIME, FO_HORIZONTAL);
        TFT_Write_Text("GAME  MENU", 95, 14);

        if (0 == FAT32_ChangeDir("GAME")) {
        Search_file();
        }
        file_ok();
}