#ifndef _MAPPER003_H_
#define _MAPPER003_H_


void Mapper003_Reset()
{
        switch(PROM_16K_SIZE) {
                case        1:        // 16K only
                        SetPROM_16K_Bank( 4, 0 );
                        SetPROM_16K_Bank( 6, 0 );
                        break;
                case        2:        // 32K
                        SetPROM_32K_Bank1( 0 );
                        break;
                        }
}

void        Mapper003_WriteLow( WORD addr, BYTE str )
{
         if( addr >= 0x4800 ) {
               SetVROM_8K_Bank( str & 0x03 );
    }
}

void Mapper003_Write(WORD addr, BYTE str)
{
        SetVROM_8K_Bank(str);
}

void Mapper003_Init()
{
        NES_Mapper.Reset = Mapper003_Reset;
        NES_Mapper.Write = Mapper003_Write;
        NES_Mapper.WriteLow = Mapper003_WriteLow;
}

#endif