#ifndef _MAPPER011_H_
#define _MAPPER011_H_


void Mapper011_Reset()
{
	SetPROM_32K_Bank1(0);

	if(RomHeader[5]*8) {
		SetVROM_8K_Bank( 0 );
//		SetVROM_8K_Bank( 1 );
	}
	SetVRAM_Mirror(0x01);
}

void Mapper011_Write(WORD addr, BYTE str)
{
	SetPROM_32K_Bank1(str);
	if(RomHeader[5]*8) {
		SetVROM_8K_Bank( str>>4 );
	}
}

void Mapper011_Init()
{
        NES_Mapper.Reset = Mapper011_Reset;
        NES_Mapper.Write = Mapper011_Write;
}

#endif