#ifndef _MAPPER079_H_
#define _MAPPER079_H_

void Mapper079_Reset()
{
	SetPROM_32K_Bank1( 0 );

	if( VROM_1K_SIZE ) {
		SetVROM_8K_Bank( 0 );
	}
}

void Mapper079_WriteLow(WORD addr, BYTE str)
{
	if( addr&0x0100 ) {
		SetPROM_32K_Bank1( (str>>3)&0x01 );
		SetVROM_8K_Bank( str&0x07 );
	}
}

void Mapper079_Init()
{
        NES_Mapper.Reset = Mapper079_Reset;
        NES_Mapper.WriteLow = Mapper079_WriteLow;
}

#endif